Loading...
Searching...
No Matches
juce::StringArray Class Reference

## Detailed Description

A special array for holding a list of strings.

See also
  String, StringPairArray

The documentation for this class was generated from the following file:

- juce_core/text/juce_StringArray.h

## Public Member Functions

| StringArray () noexcept
| Creates an empty string array.
| StringArray (const StringArray &)
| Creates a copy of another string array.
| StringArray (StringArray &&) noexcept
| Move constructor.
| StringArray (const String &firstValue)
| Creates an array containing a single string.
template<typename... OtherElements>
| StringArray (StringRef firstValue, OtherElements &&... otherValues)
| Creates an array containing a list of strings.
| StringArray (const std::initializer_list< const char * > &strings)
| Creates an array containing a list of strings.
| StringArray (Array< String > &&) noexcept
| Creates a StringArray by moving from an Array<String>.
template<typename Type>
| StringArray (const Array< Type > &stringArray)
| Creates a StringArray from an array of objects which can be implicitly converted to Strings.
| StringArray (const String *strings, int numberOfStrings)
| Creates an array from a raw array of strings.
| StringArray (const char *const *strings, int numberOfStrings)
| Creates a copy of an array of string literals.
| StringArray (const char *const *strings)
| Creates a copy of a null-terminated array of string literals.
| StringArray (const wchar_t *const *strings)
| Creates a copy of a null-terminated array of string literals.
| StringArray (const wchar_t *const *strings, int numberOfStrings)
| Creates a copy of an array of string literals.
| ~StringArray ()=default
| Destructor.
StringArray & | operator= (const StringArray &)
| Copies the contents of another string array into this one.
StringArray & | operator= (StringArray &&) noexcept
| Move assignment operator.
template<typename Type>
StringArray & | operator= (const Array< Type > &stringArray)
| Copies a StringArray from an array of objects which can be implicitly converted to Strings.
void | swapWith (StringArray &) noexcept
| Swaps the contents of this and another StringArray.
bool | operator== (const StringArray &) const noexcept
| Compares two arrays.
bool | operator!= (const StringArray &) const noexcept
| Compares two arrays.
int | size () const noexcept
| Returns the number of strings in the array.
bool | isEmpty () const noexcept
| Returns true if the array is empty, false otherwise.
const String & | operator[] (int index) const noexcept
| Returns one of the strings from the array.
String & | getReference (int index) noexcept
| Returns a reference to one of the strings in the array.
const String & | getReference (int index) const noexcept
| Returns a reference to one of the strings in the array.
String * | begin () noexcept
| Returns a pointer to the first String in the array.
const String * | begin () const noexcept
| Returns a pointer to the first String in the array.
String * | end () noexcept
| Returns a pointer to the String which follows the last element in the array.
const String * | end () const noexcept
| Returns a pointer to the String which follows the last element in the array.
bool | contains (StringRef stringToLookFor, bool ignoreCase=false) const
| Searches for a string in the array.
int | indexOf (StringRef stringToLookFor, bool ignoreCase=false, int startIndex=0) const
| Searches for a string in the array.
void | add (String stringToAdd)
| Appends a string at the end of the array.
void | insert (int index, String stringToAdd)
| Inserts a string into the array.
bool | addIfNotAlreadyThere (const String &stringToAdd, bool ignoreCase=false)
| Adds a string to the array as long as it's not already in there.
void | set (int index, String newString)
| Replaces one of the strings in the array with another one.
void | addArray (const StringArray &other, int startIndex=0, int numElementsToAdd=-1)
| Appends some strings from another array to the end of this one.
template<typename Iterator>
void | addArray (Iterator &&start, Iterator &&end)
| Adds items from a range of start/end iterators of some kind of objects which can be implicitly converted to Strings.
void | mergeArray (const StringArray &other, bool ignoreCase=false)
| Merges the strings from another array into this one.
int | addTokens (StringRef stringToTokenise, bool preserveQuotedStrings)
| Breaks up a string into tokens and adds them to this array.
int | addTokens (StringRef stringToTokenise, StringRef breakCharacters, StringRef quoteCharacters)
| Breaks up a string into tokens and adds them to this array.
int | addLines (StringRef stringToBreakUp)
| Breaks up a string into lines and adds them to this array.
void | clear ()
| Removes all elements from the array.
void | clearQuick ()
| Removes all elements from the array without freeing the array's allocated storage.
void | remove (int index)
| Removes a string from the array.
void | removeString (StringRef stringToRemove, bool ignoreCase=false)
| Finds a string in the array and removes it.
void | removeRange (int startIndex, int numberToRemove)
| Removes a range of elements from the array.
void | removeDuplicates (bool ignoreCase)
| Removes any duplicated elements from the array.
void | removeEmptyStrings (bool removeWhitespaceStrings=true)
| Removes empty strings from the array.
void | move (int currentIndex, int newIndex) noexcept
| Moves one of the strings to a different position.
void | trim ()
| Deletes any whitespace characters from the starts and ends of all the strings.
void | appendNumbersToDuplicates (bool ignoreCaseWhenComparing, bool appendNumberToFirstInstance, CharPointer_UTF8 preNumberString=CharPointer_UTF8(nullptr), CharPointer_UTF8 postNumberString=CharPointer_UTF8(nullptr))
| Adds numbers to the strings in the array, to make each string unique.
String | joinIntoString (StringRef separatorString, int startIndex=0, int numberOfElements=-1) const
| Joins the strings in the array together into one string.
void | sort (bool ignoreCase)
| Sorts the array into alphabetical order.
void | sortNatural ()
| Sorts the array using extra language-aware rules to do a better job of comparing words containing spaces and numbers.
void | ensureStorageAllocated (int minNumElements)
| Increases the array's internal storage to hold a minimum number of elements.
void | minimiseStorageOverheads ()
| Reduces the amount of storage being used by the array.

## Static Public Member Functions

static StringArray | fromTokens (StringRef stringToTokenise, bool preserveQuotedStrings)
| Returns an array containing the tokens in a given string.
static StringArray | fromTokens (StringRef stringToTokenise, StringRef breakCharacters, StringRef quoteCharacters)
| Returns an array containing the tokens in a given string.
static StringArray | fromLines (StringRef stringToBreakUp)
| Returns an array containing the lines in a given string.

## Public Attributes

Array< String > | strings
| This is the array holding the actual strings.

## Constructors and Destructors

## StringArray() [1/13]

juce::StringArray::StringArray | ( |  | ) |

noexcept

Creates an empty string array.

Referenced by addArray(), fromLines(), fromTokens(), fromTokens(), mergeArray(), operator!=(), operator=(), operator=(), operator=(), operator==(), StringArray(), StringArray(), StringArray(), StringArray(), StringArray(), and swapWith().

## StringArray() [2/13]

juce::StringArray::StringArray | ( | const StringArray & |  | ) |

Creates a copy of another string array.

References StringArray().

## StringArray() [3/13]

juce::StringArray::StringArray | ( | StringArray && |  | ) |

noexcept

Move constructor.

References StringArray().

## StringArray() [4/13]

juce::StringArray::StringArray | ( | const String & | firstValue | ) |

Creates an array containing a single string.

References StringArray().

## StringArray() [5/13]

template<typename... OtherElements>

juce::StringArray::StringArray | ( | StringRef | firstValue,
|  | OtherElements &&... | otherValues )

inline

Creates an array containing a list of strings.

References StringArray(), and strings.

## StringArray() [6/13]

juce::StringArray::StringArray | ( | const std::initializer_list< const char * > & | strings | ) |

Creates an array containing a list of strings.

References strings.

## StringArray() [7/13]

juce::StringArray::StringArray | ( | Array< String > && |  | ) |

noexcept

Creates a StringArray by moving from an Array<String>.

## StringArray() [8/13]

template<typename Type>

juce::StringArray::StringArray | ( | const Array< Type > & | stringArray | ) |

inline

Creates a StringArray from an array of objects which can be implicitly converted to Strings.

References addArray(), and StringArray().

## StringArray() [9/13]

juce::StringArray::StringArray | ( | const String * | strings,
|  | int | numberOfStrings )

Creates an array from a raw array of strings.

Parameters

  strings | an array of strings to add
  numberOfStrings | how many items there are in the array

References strings.

## StringArray() [10/13]

juce::StringArray::StringArray | ( | const char *const * | strings,
|  | int | numberOfStrings )

Creates a copy of an array of string literals.

Parameters

  strings | an array of strings to add. Null pointers in the array will be treated as empty strings
  numberOfStrings | how many items there are in the array

References strings.

## StringArray() [11/13]

juce::StringArray::StringArray | ( | const char *const * | strings | ) |

explicit

Creates a copy of a null-terminated array of string literals.

Each item from the array passed-in is added, until it encounters a null pointer, at which point it stops.

References strings.

## StringArray() [12/13]

juce::StringArray::StringArray | ( | const wchar_t *const * | strings | ) |

explicit

Creates a copy of a null-terminated array of string literals.

Each item from the array passed-in is added, until it encounters a null pointer, at which point it stops.

References strings.

## StringArray() [13/13]

juce::StringArray::StringArray | ( | const wchar_t *const * | strings,
|  | int | numberOfStrings )

Creates a copy of an array of string literals.

Parameters

  strings | an array of strings to add. Null pointers in the array will be treated as empty strings
  numberOfStrings | how many items there are in the array

References strings.

## ~StringArray()

juce::StringArray::~StringArray | ( |  | ) |

default

Destructor.

## Member Functions

## operator=() [1/3]

StringArray & juce::StringArray::operator= | ( | const StringArray & |  | ) |

Copies the contents of another string array into this one.

References StringArray().

## operator=() [2/3]

StringArray & juce::StringArray::operator= | ( | StringArray && |  | ) |

noexcept

Move assignment operator.

References StringArray().

## operator=() [3/3]

template<typename Type>

StringArray & juce::StringArray::operator= | ( | const Array< Type > & | stringArray | ) |

inline

Copies a StringArray from an array of objects which can be implicitly converted to Strings.

References addArray(), and StringArray().

## swapWith()

void juce::StringArray::swapWith | ( | StringArray & |  | ) |

noexcept

Swaps the contents of this and another StringArray.

References StringArray().

## operator==()

bool juce::StringArray::operator== | ( | const StringArray & |  | ) | const

noexcept

Compares two arrays.

Comparisons are case-sensitive.

Returns
  true only if the other array contains exactly the same strings in the same order

References StringArray().

## operator!=()

bool juce::StringArray::operator!= | ( | const StringArray & |  | ) | const

noexcept

Compares two arrays.

Comparisons are case-sensitive.

Returns
  false if the other array contains exactly the same strings in the same order

References StringArray().

## size()

int juce::StringArray::size | ( |  | ) | const

inline noexcept

Returns the number of strings in the array.

References strings.

Referenced by addArray(), isEmpty(), and juce::KeyGeneration::keyGenerationAppMain().

## isEmpty()

bool juce::StringArray::isEmpty | ( |  | ) | const

inline noexcept

Returns true if the array is empty, false otherwise.

References size().

## operator[]()

const String & juce::StringArray::operator[] | ( | int | index | ) | const

noexcept

Returns one of the strings from the array.

If the index is out-of-range, an empty string is returned.

Obviously the reference returned shouldn't be stored for later use, as the string it refers to may disappear when the array changes.

## getReference() [1/2]

String & juce::StringArray::getReference | ( | int | index | ) |

noexcept

Returns a reference to one of the strings in the array.

This lets you modify a string in-place in the array, but you must be sure that the index is in-range.

## getReference() [2/2]

const String & juce::StringArray::getReference | ( | int | index | ) | const

noexcept

Returns a reference to one of the strings in the array.

This lets you modify a string in-place in the array, but you must be sure that the index is in-range.

## begin() [1/2]

String * juce::StringArray::begin | ( |  | ) |

inline noexcept

Returns a pointer to the first String in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

References strings.

## begin() [2/2]

const String * juce::StringArray::begin | ( |  | ) | const

inline noexcept

Returns a pointer to the first String in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

References strings.

## end() [1/2]

String * juce::StringArray::end | ( |  | ) |

inline noexcept

Returns a pointer to the String which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

References strings.

Referenced by addArray().

## end() [2/2]

const String * juce::StringArray::end | ( |  | ) | const

inline noexcept

Returns a pointer to the String which follows the last element in the array.

This method is provided for compatibility with standard C++ iteration mechanisms.

References strings.

## contains()

bool juce::StringArray::contains | ( | StringRef | stringToLookFor,
|  | bool | ignoreCase = false ) const

Searches for a string in the array.

The comparison will be case-insensitive if the ignoreCase parameter is true.

Returns
  true if the string is found inside the array

## indexOf()

int juce::StringArray::indexOf | ( | StringRef | stringToLookFor,
|  | bool | ignoreCase = false,
|  | int | startIndex = 0 ) const

Searches for a string in the array.

The comparison will be case-insensitive if the ignoreCase parameter is true.

Parameters

  stringToLookFor | the string to try to find
  ignoreCase | whether the comparison should be case-insensitive
  startIndex | the first index to start searching from

Returns
  the index of the first occurrence of the string in this array, or -1 if it isn't found.

## add()

void juce::StringArray::add | ( | String | stringToAdd | ) |

Appends a string at the end of the array.

Referenced by juce::KeyGeneration::keyGenerationAppMain().

## insert()

void juce::StringArray::insert | ( | int | index,
|  | String | stringToAdd )

Inserts a string into the array.

This will insert a string into the array at the given index, moving up the other elements to make room for it. If the index is less than zero or greater than the size of the array, the new string will be added to the end of the array.

## addIfNotAlreadyThere()

bool juce::StringArray::addIfNotAlreadyThere | ( | const String & | stringToAdd,
|  | bool | ignoreCase = false )

Adds a string to the array as long as it's not already in there.

The search can optionally be case-insensitive.

Returns
  true if the string has been added, false otherwise.

## set()

void juce::StringArray::set | ( | int | index,
|  | String | newString )

Replaces one of the strings in the array with another one.

If the index is higher than the array's size, the new string will be added to the end of the array; if it's less than zero nothing happens.

## addArray() [1/2]

void juce::StringArray::addArray | ( | const StringArray & | other,
|  | int | startIndex = 0,
|  | int | numElementsToAdd = -1 )

Appends some strings from another array to the end of this one.

Parameters

  other | the array to add
  startIndex | the first element of the other array to add
  numElementsToAdd | the maximum number of elements to add (if this is less than zero, they are all added)

References StringArray().

Referenced by operator=(), and StringArray().

## addArray() [2/2]

template<typename Iterator>

void juce::StringArray::addArray | ( | Iterator && | start,
|  | Iterator && | end )

inline

Adds items from a range of start/end iterators of some kind of objects which can be implicitly converted to Strings.

References end(), ensureStorageAllocated(), size(), and strings.

## mergeArray()

void juce::StringArray::mergeArray | ( | const StringArray & | other,
|  | bool | ignoreCase = false )

Merges the strings from another array into this one.

This will not add a string that already exists.

Parameters

  other | the array to add
  ignoreCase | ignore case when merging

References StringArray().

## addTokens() [1/2]

int juce::StringArray::addTokens | ( | StringRef | stringToTokenise,
|  | bool | preserveQuotedStrings )

Breaks up a string into tokens and adds them to this array.

This will tokenise the given string using whitespace characters as the token delimiters, and will add these tokens to the end of the array.

Returns
  the number of tokens added

See also
  fromTokens

Referenced by juce::Rectangle< ValueType >::fromString().

## addTokens() [2/2]

int juce::StringArray::addTokens | ( | StringRef | stringToTokenise,
|  | StringRef | breakCharacters,
|  | StringRef | quoteCharacters )

Breaks up a string into tokens and adds them to this array.

This will tokenise the given string (using the string passed in to define the token delimiters), and will add these tokens to the end of the array.

Parameters

  stringToTokenise | the string to tokenise
  breakCharacters | a string of characters, any of which will be considered to be a token delimiter.
  quoteCharacters | if this string isn't empty, it defines a set of characters which are treated as quotes. Any text occurring between quotes is not broken up into tokens.

Returns
  the number of tokens added

See also
  fromTokens

## addLines()

int juce::StringArray::addLines | ( | StringRef | stringToBreakUp | ) |

Breaks up a string into lines and adds them to this array.

This breaks a string down into lines separated by \n or \r\n, and adds each line to the array. Line-break characters are omitted from the strings that are added to the array.

## fromTokens() [1/2]

StringArray juce::StringArray::fromTokens | ( | StringRef | stringToTokenise,
|  | bool | preserveQuotedStrings )

static nodiscard

Returns an array containing the tokens in a given string.

This will tokenise the given string using whitespace characters as the token delimiters, and return the parsed tokens as an array.

See also
  addTokens

References StringArray().

## fromTokens() [2/2]

StringArray juce::StringArray::fromTokens | ( | StringRef | stringToTokenise,
|  | StringRef | breakCharacters,
|  | StringRef | quoteCharacters )

static nodiscard

Returns an array containing the tokens in a given string.

This will tokenise the given string using the breakCharacters string to define the token delimiters, and will return the parsed tokens as an array.

Parameters

  stringToTokenise | the string to tokenise
  breakCharacters | a string of characters, any of which will be considered to be a token delimiter.
  quoteCharacters | if this string isn't empty, it defines a set of characters which are treated as quotes. Any text occurring between quotes is not broken up into tokens.

See also
  addTokens

References StringArray().

## fromLines()

StringArray juce::StringArray::fromLines | ( | StringRef | stringToBreakUp | ) |

static nodiscard

Returns an array containing the lines in a given string.

This breaks a string down into lines separated by \n or \r\n, and returns an array containing these lines. Line-break characters are omitted from the strings that are added to the array.

References StringArray().

## clear()

void juce::StringArray::clear | ( |  | ) |

Removes all elements from the array.

## clearQuick()

void juce::StringArray::clearQuick | ( |  | ) |

Removes all elements from the array without freeing the array's allocated storage.

See also
  clear

## remove()

void juce::StringArray::remove | ( | int | index | ) |

Removes a string from the array.

If the index is out-of-range, no action will be taken.

## removeString()

void juce::StringArray::removeString | ( | StringRef | stringToRemove,
|  | bool | ignoreCase = false )

Finds a string in the array and removes it.

This will remove all occurrences of the given string from the array. The comparison may be case-insensitive depending on the ignoreCase parameter.

## removeRange()

void juce::StringArray::removeRange | ( | int | startIndex,
|  | int | numberToRemove )

Removes a range of elements from the array.

This will remove a set of elements, starting from the given index, and move subsequent elements down to close the gap.

If the range extends beyond the bounds of the array, it will be safely clipped to the size of the array.

Parameters

  startIndex | the index of the first element to remove
  numberToRemove | how many elements should be removed

## removeDuplicates()

void juce::StringArray::removeDuplicates | ( | bool | ignoreCase | ) |

Removes any duplicated elements from the array.

If any string appears in the array more than once, only the first occurrence of it will be retained.

Parameters

  ignoreCase | whether to use a case-insensitive comparison

## removeEmptyStrings()

void juce::StringArray::removeEmptyStrings | ( | bool | removeWhitespaceStrings = true | ) |

Removes empty strings from the array.

Parameters

  removeWhitespaceStrings | if true, strings that only contain whitespace characters will also be removed

## move()

void juce::StringArray::move | ( | int | currentIndex,
|  | int | newIndex )

noexcept

Moves one of the strings to a different position.

This will move the string to a specified index, shuffling along any intervening elements as required.

So for example, if you have the array { 0, 1, 2, 3, 4, 5 } then calling move (2, 4) would result in { 0, 1, 3, 4, 2, 5 }.

Parameters

  currentIndex | the index of the value to be moved. If this isn't a valid index, then nothing will be done
  newIndex | the index at which you'd like this value to end up. If this is less than zero, the value will be moved to the end of the array

## trim()

void juce::StringArray::trim | ( |  | ) |

Deletes any whitespace characters from the starts and ends of all the strings.

## appendNumbersToDuplicates()

void juce::StringArray::appendNumbersToDuplicates | ( | bool | ignoreCaseWhenComparing,
|  | bool | appendNumberToFirstInstance,
|  | CharPointer_UTF8 | preNumberString = CharPointer_UTF8(nullptr),
|  | CharPointer_UTF8 | postNumberString = CharPointer_UTF8(nullptr) )

Adds numbers to the strings in the array, to make each string unique.

This will add numbers to the ends of groups of similar strings. e.g. if there are two "moose" strings, they will become "moose (1)" and "moose (2)"

Parameters

  ignoreCaseWhenComparing | whether the comparison used is case-insensitive
  appendNumberToFirstInstance | whether the first of a group of similar strings also has a number appended to it.
  preNumberString | when adding a number, this string is added before the number. If you pass nullptr, a default string will be used, which adds brackets around the number.
  postNumberString | this string is appended after any numbers that are added. If you pass nullptr, a default string will be used, which adds brackets around the number.

## joinIntoString()

String juce::StringArray::joinIntoString | ( | StringRef | separatorString,
|  | int | startIndex = 0,
|  | int | numberOfElements = -1 ) const

Joins the strings in the array together into one string.

This will join a range of elements from the array into a string, separating them with a given string.

e.g. joinIntoString (",") will turn an array of "a" "b" and "c" into "a,b,c".

Parameters

  separatorString | the string to insert between all the strings
  startIndex | the first element to join
  numberOfElements | how many elements to join together. If this is less than zero, all available elements will be used.

## sort()

void juce::StringArray::sort | ( | bool | ignoreCase | ) |

Sorts the array into alphabetical order.

Parameters

  ignoreCase | if true, the comparisons used will not be case-sensitive.

## sortNatural()

void juce::StringArray::sortNatural | ( |  | ) |

Sorts the array using extra language-aware rules to do a better job of comparing words containing spaces and numbers.

See also
  String::compareNatural()

## ensureStorageAllocated()

void juce::StringArray::ensureStorageAllocated | ( | int | minNumElements | ) |

Increases the array's internal storage to hold a minimum number of elements.

Calling this before adding a large known number of elements means that the array won't have to keep dynamically resizing itself as the elements are added, and it'll therefore be more efficient.

Referenced by addArray().

## minimiseStorageOverheads()

void juce::StringArray::minimiseStorageOverheads | ( |  | ) |

Reduces the amount of storage being used by the array.

Arrays typically allocate slightly more storage than they need, and after removing elements, they may have quite a lot of unused space allocated. This method will reduce the amount of allocated storage to a minimum.

## Member Data Documentation

## strings

Array<String> juce::StringArray::strings

This is the array holding the actual strings.

This is public to allow direct access to array methods that may not already be provided by the StringArray class.

Referenced by addArray(), begin(), begin(), end(), end(), size(), StringArray(), StringArray(), StringArray(), StringArray(), StringArray(), StringArray(), and StringArray().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited